/* -*- c++ -*- */
#include <winsock2.h>
#include <winbase.h>
#include <winuser.h>
#include <stdio.h>

#include "global.h"
#include "escape.h"
#include "charcode.h"
#include "code.h"

#define TNT_VERSION "tnt version 1.07"
#define COPY_LEFT "programed by Applause"
#define BUILD_DATE __DATE__

#define FOREGROUND_WHITE (FOREGROUND_RED|FOREGROUND_GREEN|FOREGROUND_BLUE)
#define EITHER_CTRL_PRESSED (LEFT_CTRL_PRESSED | RIGHT_CTRL_PRESSED)
#define EITHER_ALT_PRESSED (LEFT_ALT_PRESSED | RIGHT_ALT_PRESSED)


void checkWindowSize(void);
unsigned char recvchar(SOCKET);
void sendchar(unsigned char);
void convertandsendkey(unsigned char,unsigned char,DWORD);
void sendflush(void);
int open_debug_socket(void);
void printerror(char *,DWORD);
void restoreConsoleSetting(void);
void authentication(int telnetsocket);
void receivebytes(SOCKET s, void *buf,DWORD bytes);
void send_bytes(SOCKET s, unsigned char *buf,DWORD bytes);
void dump(unsigned char *buf,int len);

//CONSOLE_SCREEN_BUFFER_INFO buffer_info,buffer_info_back;
SMALL_RECT srWindow_back={-1,0,0,0};
SOCKADDR_IN debug_addr;

#define RECVBUF_SIZE 4096
unsigned char recvbuf[RECVBUF_SIZE];
int recvbytes=0;
int recvindex=0;
#define SENDBUF_SIZE 4096
unsigned char sendbuf[SENDBUF_SIZE];
int sendbytes=0;
int sendindex=0;
int SJIS1=0;

static int including_ff=FALSE;
static unsigned char authdata1[]={
  0xff,0xfa,0x25,0x00,0x0f,0x00,0x00,
  0x20,0x00,0x00,0x00,0x02,0x00,0x00,0x00,
  0x4E,0x54,0x4C,0x4D,0x53,0x53,0x50,0x00,
  0x01,0x00,0x00,0x00,0x97,0x82,0x00,0xC0,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0xFF,0xF0,
};


void sendWill(unsigned char c){
    unsigned char buf[3];
    buf[0]=0xff;
    buf[1]=0xfb; //will
    buf[2]=c;
    send(telnetsocket,buf,3,0);
}

void sendWont(unsigned char c){
    unsigned char buf[3];
    buf[0]=0xff;
    buf[1]=0xfc; //won't
    buf[2]=c;
    send(telnetsocket,buf,3,0);
}

void sendDo(unsigned char c){
    unsigned char buf[3];
    buf[0]=0xff;
    buf[1]=0xfd; // DO
    buf[2]=c;
    send(telnetsocket,buf,3,0);
}

void sendDont(unsigned char c){
    unsigned char buf[3];
    buf[0]=0xff;
    buf[1]=0xfe; // DON'T
    buf[2]=c;
    send(telnetsocket,buf,3,0);
}





unsigned char recvchar(SOCKET s){
    static unsigned char c;
    static int err;
	
    if(recvbytes==0){
	recvbytes=recv(telnetsocket,recvbuf,RECVBUF_SIZE,0);
	if(recvbytes==0){
	    escOutputFlush();
	    restoreConsoleSetting();
	    printf("Connection Closed!\n");
#if DEBUG
	    closesocket(debugsocket);
#endif
	    if(including_ff){
		printf("Yes Including 0xff!\n");
	    }
	    exit(7);
	}else if(recvbytes==SOCKET_ERROR){
	    restoreConsoleSetting();
	    printerror("Error5",WSAGetLastError());
	    exit(8);
	}
	recvindex=0;
    }

    recvbytes--;
    c=recvbuf[recvindex++];
#if DEBUG
    send(debugsocket,&c,1,0);
#endif
    return c;
}

void sendflush(){
    int i;
    i=0;
    while(i!=sendbytes){
	i+=send(telnetsocket,&sendbuf[i],sendbytes-i,0);
    }
    sendindex=0;
    sendbytes=0;
}

void sendchar(unsigned char c){
    sendbuf[sendindex++]=c;
    sendbytes++;
    if(sendbytes==SENDBUF_SIZE){
	sendflush();
    }
}


// DEBUG ́Alocalhost ̃|[g24Ńj^p̃vO𓮂ĎgB
#if DEBUG
int open_debug_socket(void){
    int err;
    debugsocket=socket(AF_INET,SOCK_STREAM,PF_UNSPEC);
    if(debugsocket==INVALID_SOCKET){
	printf("DebugError1=%d\n",WSAGetLastError());
	return -1;
    }
    debug_addr.sin_family=AF_INET;
    debug_addr.sin_port=htons(24);
    debug_addr.sin_addr.S_un.S_addr=htonl(INADDR_LOOPBACK);
    err=connect(debugsocket,(SOCKADDR FAR *)&debug_addr,sizeof(debug_addr));
    if(err==SOCKET_ERROR){
	printf("DebugError2=%d\n",WSAGetLastError());
	debugsocket=INVALID_SOCKET;
	return -1;
    }
}
#endif

void convertandsendkey(unsigned char charcode,unsigned char keycode,
		  DWORD controlkeystate){
    if((keycode==VK_BACK || keycode==VK_F12) && 
       (controlkeystate & EITHER_CTRL_PRESSED)!=0 &&
       (controlkeystate & EITHER_ALT_PRESSED)!=0){
	closesocket(telnetsocket);
#if DEBUG
	if(debugsocket!=INVALID_SOCKET)
	    closesocket(debugsocket);
#endif
	restoreConsoleSetting();
	printf("User Exit\n");
	exit(0);
    }
    if(keycode==VK_F1 && 
       (controlkeystate & EITHER_CTRL_PRESSED)!=0 &&
       (controlkeystate & EITHER_ALT_PRESSED)!=0){
	escSetKanjiMode(KM_EUC);
	INPUT_KANJI_MODE=KM_EUC;
	return;
    }
    if(keycode==VK_F2 && 
       (controlkeystate & EITHER_CTRL_PRESSED)!=0 &&
       (controlkeystate & EITHER_ALT_PRESSED)!=0){
	escSetKanjiMode(KM_SJIS);
	INPUT_KANJI_MODE=KM_SJIS;
	return;
    }
    if(keycode==VK_F3 && 
       (controlkeystate & EITHER_CTRL_PRESSED)!=0 &&
       (controlkeystate & EITHER_ALT_PRESSED)!=0){
	INPUT_KANJI_MODE=KM_ISO;
	return;
    }

    switch(INPUT_KANJI_MODE){
    case KM_SJIS:
	break;
    case KM_EUC:
	if(SJIS1!=0){
	    unsigned int kanjicode;
	    kanjicode=sjistojis((SJIS1<<8)|charcode);
	    sendchar((unsigned char)((kanjicode >>8)|0x80));
	    sendchar((unsigned char)((kanjicode & 0xff)|0x80));
	    SJIS1=0;
	    return;
	}else if(issjis1(charcode)){
	    SJIS1=charcode;
	    return;
	}else if(iskata(charcode)){
	    sendchar(0x8e);
	    sendchar(charcode);
	    return;
	}
	break;
    case KM_ISO:
	if(SJIS1!=0){
	    unsigned int kanjicode;
	    kanjicode=sjistojis((SJIS1<<8)|charcode);
	    sendchar(0x1b);
	    sendchar('$');
	    sendchar('B');
	    sendchar((unsigned char)(kanjicode >>8));
	    sendchar((unsigned char)(kanjicode & 0xff));
	    sendchar(0x1b);
	    sendchar('(');
	    sendchar('B');
	    SJIS1=0;
	    return;
	}else if(issjis1(charcode)){
	    SJIS1=charcode;
	    return;
	}else if(iskata(charcode)){
	    sendchar(0x1b);
	    sendchar('(');
	    sendchar('I');
	    sendchar((unsigned char)(charcode-0x80));
	    sendchar(0x1b);
	    sendchar('(');
	    sendchar('B');
	    return;
	}
	break;
    }

    switch(keycode){
//    case VK_BACK:
//	sendchar(0x7f);
//	break;
    case VK_SPACE:
	if(controlkeystate & EITHER_CTRL_PRESSED){
	    sendchar(0);
	}else{
	    sendchar(charcode);
	}
	break;
    case VK_RETURN:
	sendchar(0xd);
	sendchar(0);
	break;
    default:
	if(charcode!=0){
	    if((controlkeystate & EITHER_ALT_PRESSED)!=0){
		sendchar(ESC);
		sendchar(charcode);
	    }else{
		sendchar(charcode);
	    }
	}else{
	    escSendSpecialKey(telnetsocket,keycode,controlkeystate);
	}
    }
}

void checkWindowSize(void){
    unsigned char buf[16];
    if(!optionNAWS)return;
    GetConsoleScreenBufferInfo(hstdout,&buffer_info);
//    if((buffer_info.dwSize.X!=dwSize_back.X)
//       || (buffer_info.dwSize.Y!=dwSize_back.Y)){
    if(buffer_info.srWindow.Top!=srWindow_back.Top ||
       buffer_info.srWindow.Bottom!=srWindow_back.Bottom){
//	Beep(440,100);
	buf[0]=0xff;        //IAC
	buf[1]=0xfa;        //SB
	buf[2]=31;          //NAWS (Window Size)
	buf[3]=buffer_info.dwSize.X >>8;
	buf[4]=buffer_info.dwSize.X & 0xff;
	{
	    int height;
	    height=buffer_info.srWindow.Bottom
	      -buffer_info.srWindow.Top+1-1;
	    // height-=1; // 
	    buf[5]=height>>8;
	    buf[6]=height & 0xff;
	}
	buf[7]=0xff;        //IAC
	buf[8]=0xf0;        //SE
	send(telnetsocket,buf,9,0);
    }
    srWindow_back=buffer_info.srWindow;
}

void printerror(char *errstr,DWORD err){
    printf("%s : ",errstr);
    switch(err){
    case WSAENETUNREACH:
        printf("Network Unreachable!\n");
	break;
    case WSAECONNREFUSED:
	printf("ConnectionRefused!\n");
	break;
    case WSAECONNRESET:
	printf("ConnectionReset!\n");
	break;
    case WSAETIMEDOUT:
	printf("Timed Out!\n");
	break;
    case WSAHOST_NOT_FOUND:
	printf("Cannot Resolve the Name\n");
	break;
    case WSATRY_AGAIN:
	printf("WSATRY_AGAIN\n");
	break;
    case WSANO_RECOVERY:
	printf("WSANO_RECOVERY\n");
	break;
    case WSANO_DATA: //==WSANO_ADDRESS
	printf("WSANO_DATA or WSANO_ADDRESS\n");
	break;
    default:
	printf("ErrorCode=%08X(%d)\n",errstr,err);
    }
    return;
}

void restoreConsoleSetting(void){
    SetConsoleTextAttribute(hstdout,FOREGROUND_WHITE);
}

#include "security.h"

static DWORD g_cbMaxMessage = 0;
static PBYTE g_pInBuf = NULL;
static PBYTE g_pOutBuf = NULL;


void authentication(int telnetsocket){
    unsigned char c,c1,c2;
    int i;
    int serial;
    DWORD cbOut, cbIn;
    DWORD endbytes;
    BOOL done;

    c=recvchar(telnetsocket);
    switch(c){
    case 1: // SEND
	i=0;
	do{
	    c1=recvchar(telnetsocket);
	    c2=recvchar(telnetsocket);
	    if(c1==0xf && c2==0){
		enable_ntlm_authentication=1;
	    }
	}while(c1!=0xff || c2!=0xf0);

	if(enable_ntlm_authentication){
	    if (!InitPackage (&g_cbMaxMessage)){
		fprintf(stderr,"Error in line %d!\n",__LINE__);
		exit(1);
	    }

	    g_pInBuf = (PBYTE) malloc (g_cbMaxMessage);
	    g_pOutBuf = (PBYTE) malloc (g_cbMaxMessage);
	    if (NULL == g_pInBuf || NULL == g_pOutBuf){
		fprintf(stderr,"Error in line %d!\n",__LINE__);
		exit(1);
	    }
	    if(!InitSession(telnetsocket)){
		fprintf(stderr,"Error in line %d!\n",__LINE__);
		exit(1);
	    }

	    cbOut = g_cbMaxMessage;
	    if(!GenClientContext(telnetsocket,NULL,0,g_pOutBuf,&cbOut,&done)){
		fprintf(stderr,"Error in line %d!\n",__LINE__);
		exit(1);
	    }
	    dump(g_pOutBuf,cbOut);
	    send(telnetsocket,"\xff\xfa\x25\x00\x0f\x00\x00",7,0);
            // [IAC][SB][AUTHENTICATION][IS][NTLM][NULL][AUTH]
	    send_bytes(telnetsocket,(char *)&cbOut,4);
	    send(telnetsocket,"\x02\x00\x00\x00",4,0);
	    send_bytes(telnetsocket,g_pOutBuf,cbOut);
	    send(telnetsocket,"\xff\xf0",2,0); // [IAC][SE]

	}else{
	    // When NTLM not supported.
	    send(telnetsocket,"\xff\xfa\x25\x00\x00\x00\xff\xf0",8,0);
            // [IAC][SB][AUTHENTICATION][IS][NULL][NULL][IAC][SE]
	}
	break;
    case 2: // REPLY
	c1=recvchar(telnetsocket);
	c2=recvchar(telnetsocket);
	if(c1!=0x0f || c2!=0x00){
	    fprintf(stderr,"Error in line %d!\n",__LINE__);
	    exit(1);
	}
	serial=recvchar(telnetsocket);
	if(serial!=3 && serial!=4){
	    receivebytes(telnetsocket,&cbIn,4);
	    receivebytes(telnetsocket,&endbytes,4);
	    if(endbytes!=2){
		fprintf(stderr,"Error in line %d!\n",__LINE__);
#ifdef DEBUG
		shutdown(debugsocket,SD_SEND);
#endif	    
		exit(1);
	    }
	    receivebytes(telnetsocket,g_pInBuf,cbIn);
	    dump(g_pInBuf,cbIn);
	}
	c1=recvchar(telnetsocket);
	c2=recvchar(telnetsocket);
	if(c1!=0xff || c2!=0xf0){
	    fprintf(stderr,"Error in line %d!\n",__LINE__);
	    exit(1);
	}
	if(serial!=3 && serial!=4){
	    cbOut = g_cbMaxMessage;
	    if(!GenClientContext(telnetsocket,g_pInBuf,cbIn,g_pOutBuf,&cbOut,&done)){
		fprintf(stderr,"Error in line %d!\n",__LINE__);
		exit(1);
	    }
	    dump(g_pOutBuf,cbOut);
	    send(telnetsocket,"\xff\xfa\x25\x00\x0f\x00\x02",7,0);
	    // [IAC][SB][AUTHENTICATION][IS][NTLM][NULL][RESPONSE]
	    send_bytes(telnetsocket,(char *)&cbOut,4);
	    send(telnetsocket,"\x02\x00\x00\x00",4,0);
	    send_bytes(telnetsocket,g_pOutBuf,cbOut);
	    send(telnetsocket,"\xff\xf0",2,0); // [IAC][SE]
	}else{
	    if(serial==3){ // ACCEPT
		escSetKanjiMode(KM_SJIS);
		INPUT_KANJI_MODE=KM_SJIS;
	    }else{ // REJECT
	    }
	}
	break;
    }
}


void receivebytes(SOCKET s, unsigned char *buf,DWORD bytes){
    int i;
    for(i=0;i<bytes;i++){
	buf[i]=recvchar(s);
	if(buf[i]==0xff){
	    if(recvchar(s)!=0xff){
		fprintf(stderr,"Error in line %d!\n",__LINE__);
		exit(1);
	    }
	}
    }
}

void send_bytes(SOCKET s, unsigned char *buf,DWORD bytes){
    int i;
    for(i=0;i<bytes;i++){
	if(buf[i]==0xff){
	    send(s,"\xff\xff",2,0);
	    including_ff=TRUE;
	}else{
	    send(s,buf+i,1,0);
	}
    }
}

void dump(unsigned char *buf,int len){
#ifdef DEBUG
  int i=0;
  for(i=0;i<len;i++){
    if((i & 0xf)==0)
      printf("%08X  ",i);
    printf("%02X",buf[i]);
    switch(i & 0xf){
    case 7:
      printf("-");
      break;
    case 15:
      printf("\n");
      break;
    default:
      printf(",");
    }
  }
  if((len & 0xf)!=0){
    printf("\n");
  }
  fflush(stdout);
#endif
}
